﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion


using System.Windows.Forms;
using HeuristicLab.Clients.Hive.SlaveCore.Views;

namespace HeuristicLab.Clients.Hive.Slave.App {
  public partial class MainWindow : Form {
    public MainWindow() {
      InitializeComponent();
      slaveMainView.WindowStateChanged += new System.EventHandler<Common.EventArgs<FormWindowState>>(slaveMainView_WindowStateChanged);
    }

    void slaveMainView_WindowStateChanged(object sender, Common.EventArgs<FormWindowState> e) {
      WindowState = e.Value;
      if (WindowState == FormWindowState.Minimized) {
        Hide();
      } else if (WindowState == FormWindowState.Normal) {
        Show();
      }
    }

    public void SetContent(SlaveItem item) {
      slaveMainView.Content = item;
    }

    private void MainWindow_FormClosing(object sender, FormClosingEventArgs e) {
      if (e.CloseReason == CloseReason.UserClosing) {
        e.Cancel = true;
        slaveMainView.MinimizeToTray();
      }
    }
  }
}
